#!/usr/bin/env R


#setwd("~/Desktop/own_HMM_library")

####################################
### Input of the different files ###
####################################

gene_table_HMM<-read.delim(file = snakemake@input[[1]], comment.char="#")
translation<-read.delim(file = snakemake@input[[2]], header=FALSE)
signalP<-read.table(file = snakemake@input[[3]], sep= "\t")

gene_table_HMM<-gene_table_HMM[,c(1,2,4,3)]

colnames(signalP)<-c("Query_sequence","SignalP")

colnames(translation)<-c("ID","Query_sequence")
translation<-translation[,c(2,1)]

#Description file of the HMM
library_HMM<-read.table(file = snakemake@input[[4]], sep = ";", header = T, quote = '#')
colnames(library_HMM)<-c("HMM_ID","NAME","Alternative_name", "Database", "Description")
gene_table_library<-merge.data.frame(gene_table_HMM, library_HMM, by.x= "HMM_Name", by.y= "HMM_ID")
gene_table_library<-gene_table_library[,c(2,1,3,4,5,6,7,8)]

gene_table_library<-merge.data.frame(translation, gene_table_library, by.x = "ID", by.y = "Query_sequence")
gene_table_library$ID<-sprintf("%010d",as.numeric(gene_table_library$ID))

write.csv(gene_table_library,file = snakemake@output[[1]])

#Toxin/Non-Toxin file
frequency<-data.frame(table(gene_table_HMM[1]))
prediction<-data.frame(rep(1,length(table(gene_table_HMM[1]))))
table_pathos_freq<-cbind.data.frame(frequency,prediction)
colnames(table_pathos_freq)<-c("Query_sequence","Number_of_Hits","Prediction")

protein_number<-nrow(translation)
number<-cbind(c(seq(1,protein_number,1)),c(seq(1,protein_number,1)))

gene_table_Toxic<-merge.data.frame(table_pathos_freq,number,by.x = "Query_sequence",by.y = "V1", all.y = T)
gene_table_Toxic$Query_sequence=NULL
gene_table_Toxic<-gene_table_Toxic[,c(3,1,2)]
colnames(gene_table_Toxic)<-c("Query_sequence","Number_of_Hits","Prediction")

gene_table_Toxic[c("Number_of_Hits","Prediction")][is.na(gene_table_Toxic[c("Number_of_Hits","Prediction")])]<-0

gene_table_Toxic$Prediction<-gsub(0,"non-pathogenic",gene_table_Toxic$Prediction)
gene_table_Toxic$Prediction<-gsub(1,"pathogenic",gene_table_Toxic$Prediction)
gene_table_Toxic<-as.data.frame(gene_table_Toxic)

#Merge SignalP and Toxic HMM
gene_table_Toxic<-merge.data.frame(gene_table_Toxic,signalP,by="Query_sequence")
gene_table_Toxic$Query_sequence<-sprintf("%010d",as.numeric(gene_table_Toxic$Query_sequence))

write.csv(gene_table_Toxic,file = snakemake@output[[2]])
